<?php
if (!class_exists('gtk')) {
    if (strtoupper(substr(PHP_OS, 0,3) == 'WIN'))
    dl('php_gtk.dll');
  else
    dl('php_gtk.so');
}
require_once("./clases_gtk/zen_menu_gtk.php");
class zen_ventana_principal extends GtkWindow
{
    var $img = null;
    var $cargaVista = true;
		var $menu = null ;
		var $menus= array();
		var $contenedor = null;
    function __construct()
    {
	//Inicializaciones
        parent::__construct();
        $this->connect_simple('destroy', array('Gtk', 'main_quit'));
        $this->contenedor = new GtkVBox(false); //No homogéneo...
	//Crea los menús...
	$this->asociar_menus();
	//Añadir contenedor principal:
        $this->contenedor->add($this->__crear_navegador());
	$this->add($this->contenedor);

	//Parámetros de la ventana principal:
        $this->set_title("Generador de aplicaciones de zenphp::".__CLASS__);
        $this->set_default_size(500, 400);
        $this->set_position(Gtk::WIN_POS_CENTER);
	//Mostrar
        $this->show_all();
    }

    function asociar_menus(){
	$this->menu =& new zen_menu_gtk();
	$this->menu->crear_desde_xml("zen_generador.xml");
	$this->menu->set_size_request(135,24);
	
	$this->connect_simple('destroy', array('Gtk', "main_quit"));
	$this->menus['abrir'] = $this->menu->obtenerWidget("mnu_abrir");
	$this->menus['abrir'] -> connect_simple("activate", "evento_menu", "mnu_abrir");
	
	$this->menus['guardar'] = $this->menu->obtenerWidget("mnu_guardar");
	$this->menus['guardar']->connect_simple("activate", "evento_menu", "mnu_guardar");
	
	$this->menus['generar'] = $this->menu->obtenerWidget("mnu_generar");
	$this->menus['generar']->connect_simple("activate", "evento_menu", "mnu_generar");
	
	$this->menus['cerrar'] = $this->menu->obtenerWidget("mnu_cerrar");
	$this->menus['cerrar']->connect_simple("activate", "evento_menu", "mnu_cerrar");
	
	
	$this->menus['salir'] = $this->menu->obtenerWidget("mnu_salir");
	$this->menus['salir']->connect_simple("activate", "salir_generador");
	
	$this->menus['cortar'] = $this->menu->obtenerWidget("mnu_cortar");
	$this->menus['cortar']->connect_simple("activate", "evento_menu", "mnu_cortar");
	
	$this->menus['copiar'] = $this->menu->obtenerWidget("mnu_copiar");
	$this->menus['copiar']->connect_simple("activate", "evento_menu", "mnu_copiar");
	
	$this->menus['pegar'] = $this->menu->obtenerWidget("mnu_pegar");
	$this->menus['pegar']->connect_simple("activate", "evento_menu", "mnu_pegar");
	
	$this->menus['personal'] = $this->menu->obtenerWidget("mnu_personal");
	$this->menus['personal']->connect_simple("activate", "evento_menu", "mnu_personal");
	
	$this->menus['submenu']= $this->menu->obtenerWidget("mnu_submenuitem");
	$this->menus['submenu']->connect_simple("activate", "evento_menu", "submenuItem");
	$this->contenedor->pack_start($this->menu,false,false,false);
    }


    function __crear_navegador()
    {
        $box = new GtkVBox();
        $box->pack_start(new GtkLabel('Doble click para abrir el cartucho, o seleccionarlo y pulsar ENTER'), false);

        $paned = new GtkHPaned();
        $paned->set_position(200);

        //filename, markup-filename, fullpath, is_dir, preview image
        $mFile = new GtkListStore(GObject::TYPE_STRING, GObject::TYPE_STRING, GObject::TYPE_STRING, GObject::TYPE_BOOLEAN, GdkPixbuf::gtype);
        $mFile->set_sort_column_id(0, Gtk::SORT_ASCENDING);

        $vFile = new GtkTreeView($mFile);
        $col = new GtkTreeViewColumn(
                'Image',
                new GtkCellRendererPixbuf(),
                'pixbuf',
                4
            );
        $text = new GtkCellRendererText();
        $col->pack_start($text);
        $col->add_attribute($text, 'markup', 1);
        $vFile->append_column($col);
        $vFile->set_headers_visible(false);

        $vFile->connect('key-press-event', array($this, 'onPressFile'));
        $vFile->connect('button-press-event', array($this, 'onPressFile'));
/*
    GtkIconView has some problems with text that are too long
      and missing icons
        $vFile = new GtkIconView();
        $vFile->set_model($mFile);
        $vFile->set_columns(1);
        $vFile->set_pixbuf_column(3);
        $vFile->set_text_column(0);
        $vFile->set_item_width(100);
*/
        $this->loadFiles($mFile, getcwd());

        $scrwndFiles = new GtkScrolledWindow();
        $scrwndFiles->add($vFile);
        $scrwndFiles->set_policy(Gtk::POLICY_AUTOMATIC, Gtk::POLICY_AUTOMATIC);

        $vboxFile = new GtkVBox();
        $vboxFile->pack_start($scrwndFiles);

        $chkImg = new GtkCheckbutton('Incluir el motor zenphp en el directorio de salida');
        $chkImg->set_active(true);
        $chkImg->connect('toggled', array($this, 'onCheckPreview'));
        $vboxFile->pack_start($chkImg, false);
        $paned->add1($vboxFile);


        $this->img = new GtkImage();

        $scrwndImg = new GtkScrolledWindow();
        $scrwndImg->add_with_viewport($this->img);
        $scrwndImg->set_policy(Gtk::POLICY_AUTOMATIC, Gtk::POLICY_AUTOMATIC);
        $paned->add2($scrwndImg);

        $box->pack_end($paned);
        return $box;
    }



    function loadFiles($mFile, $strDir)
    {
        $hdl = dir($strDir);
        $mFile->clear();
        $pb = null;
        while (false !== ($file = $hdl->read())) {
            $path = $hdl->path . DIRECTORY_SEPARATOR . $file;
            if (is_dir($path) && $file !== '.') {
                $mFile->append(array($file, '<span color="#00F">' . $file . '</span>', $path, true, null));
            } else if (substr($path, -4) == '.png' || substr($path, -4) == '.jpg') {
                if ($this->cargaVista) {
                    $pb = GdkPixbuf::new_from_file($path)->scale_simple(32, 32, Gdk::INTERP_BILINEAR);
                }
                $mFile->append(array($file, $file, $path, false, $pb));
            }
        }
    }



    function onPressFile($vFile, $event)
    {
        if (
            ($event->type == Gdk::KEY_PRESS && $event->keyval == Gdk::KEY_Return)
         || ($event->type == Gdk::_2BUTTON_PRESS && $event->button == 1)
        ) {
            list($model, $iter) = $vFile->get_selection()->get_selected();
            if ($iter !== null) {
                $path = $model->get_value($iter, 2);
                if ($model->get_value($iter, 3)) {
                    $this->loadFiles($model, $path);
                } else {
                    $this->showImage($path);
                }
            }
        }
    }



    public function onCheckPreview($chkImg)
    {
        $this->cargaVista = $chkImg->get_active();
    }



    function showImage($path)
    {
        $this->img->set_from_file($path);
    }

}
?>